### You're not signed in!

Sign in to save your progress and sync your settings across devices.

# Prefix Sums

Authors: Darren Yao, Eric Wei

### Prerequisites

Computing range sum queries in constant time over a fixed array.

Focus Problem – read through this problem before continuing!

## Resources

Resources: Additional | |||
---|---|---|---|

IUSACO | module is based off this | ||

CPH | rather brief | ||

PAPS | also rather brief |

## Introduction

Let's say we have a one-indexed integer array $\texttt{arr}$ of size $N$ and we want to compute the value of

$\texttt{arr}[a]+\texttt{arr}[a+1]+\cdots+\texttt{arr}[b]$for $Q$ different pairs $(a,b)$ satisfying $1\le a\le b\le N$. We'll use the following example with $N = 6$:

Index $i$ | 1 | 2 | 3 | 4 | 5 | 6 |
---|---|---|---|---|---|---|

$\texttt{arr}[i]$ | 1 | 6 | 4 | 2 | 5 | 3 |

Naively, for every query, we can iterate through all entries from index $a$ to index $b$ to add them up. Since we have $Q$ queries and each query requires a maximum of $O(N)$ operations to calculate the sum, our total time complexity is $O(NQ)$. For most problems of this nature, the constraints will be $N, Q \leq 10^5$, so $NQ$ is on the order of $10^{10}$. This is **not** acceptable; it will almost certainly exceed the time limit.

Instead, we can use prefix sums to process these array sum queries. We designate a prefix sum array $\texttt{prefix}$. First, because we're 1-indexing the array, set $\texttt{prefix}[0]=0$, then for indices $k$ such that $1 \leq k \leq n$, define the prefix sum array as follows:

$\texttt{prefix}[k]=\sum_{i=1}^{k} \texttt{arr}[i]$Basically, what this means is that the element at index $k$ of the prefix sum array stores the sum of all the elements in the original array from index $1$ up to $k$. This can be calculated easily in $O(N)$ by the following formula for each $1\le k\le n$:

$\texttt{prefix}[k]=\texttt{prefix}[k-1]+\texttt{arr}[k]$For the example case, our prefix sum array looks like this:

Index $i$ | 0 | 1 | 2 | 3 | 4 | 5 | 6 |
---|---|---|---|---|---|---|---|

$\texttt{prefix}[i]$ | 0 | 1 | 7 | 11 | 13 | 18 | 21 |

Now, when we want to query for the sum of the elements of $\texttt{arr}$ between (1-indexed) indices $a$ and $b$ inclusive, we can use the following formula:

$\sum_{i=L}^{R} \texttt{arr}[i] = \sum_{i=1}^{R} \texttt{arr}[i] - \sum_{i=1}^{L-1} \texttt{arr}[i]$Using our definition of the elements in the prefix sum array, we have

$\sum_{i=L}^{R} \texttt{arr}[i]= \texttt{prefix}[R]-\texttt{prefix}[L-1]$Since we are only querying two elements in the prefix sum array, we can calculate subarray sums in $O(1)$ per query, which is much better than the $O(N)$ per query that we had before. Now, after an $O(N)$ preprocessing to calculate the prefix sum array, each of the $Q$ queries takes $O(1)$ time. Thus, our total time complexity is $O(N+Q)$, which should now pass the time limit.

Let's do an example query and find the subarray sum between indices $a = 2$ and $b = 5$, inclusive, in the 1-indexed $\texttt{arr}$. From looking at the original array, we see that this is

$\sum_{i=2}^{5} \texttt{arr}[i] = 6 + 4 + 2 + 5 = 17.$Index $i$ | 1 | 2 | 3 | 4 | 5 | 6 |
---|---|---|---|---|---|---|

$\texttt{arr}[i]$ | 1 | 6 | 4 | 2 | 5 | 3 |

Using prefix sums:

$\texttt{prefix}[5] - \texttt{prefix}[1] = 18 - 1 = 17.$Index $i$ | 0 | 1 | 2 | 3 | 4 | 5 | 6 |
---|---|---|---|---|---|---|---|

$\texttt{prefix}[i]$ | 0 | 1 | 7 | 11 | 13 | 18 | 21 |

These are also known as partial sums.

### Problems

Status | Source | Problem Name | Difficulty | Tags | Solution |
---|---|---|---|---|---|

LC | Very Easy | Show Sketch | |||

Silver | Very Easy | ||||

Silver | Easy | ||||

Silver | Easy | ||||

CSES | Easy | Show Sketch | |||

CSES | Easy | Show Sketch | |||

Silver | Normal | ||||

Old Bronze | Normal |

### Warning!

The last problem isn't submittable on USACO. Download the test data and use the script provided here to test your solution.

## Max Subarray Sum

Now we'll look at some extensions.

Focus Problem – read through this problem before continuing!

This problem has a solution known as Kadane's Algorithm. Please don't use that solution; try to solve it with prefix sums.

Why are the two methods equivalent?

## Prefix Minimum, XOR, etc.

Resources: Additional | |||
---|---|---|---|

CPH | defines XOR |

Similar to prefix sums, you can also take prefix minimum or maximum; but *you cannot* answer min queries over an arbitrary range with prefix minimum. (This is because minimum doesn't have an inverse operation, the way subtraction is to addition.) On the other hand, XOR is its own inverse operation, meaning that the XOR of any number with itself is zero.

Status | Source | Problem Name | Difficulty | Tags | Solution |
---|---|---|---|---|---|

Silver | Easy | ## Show TagsPrefix Sums | External Sol | ||

CSES | Easy | ## Show TagsPrefix Sums | Show Sketch |

## 2D Prefix Sums

Focus Problem – read through this problem before continuing!

Now, what if we wanted to process $Q$ queries for the sum over a subrectangle of a $N$ rows by $M$ columns matrix in two dimensions? Let's assume both rows and columns are 1-indexed, and we use the following matrix as an example:

0 | 0 | 0 | 0 | 0 | 0 |

0 | 1 | 5 | 6 | 11 | 8 |

0 | 1 | 7 | 11 | 9 | 4 |

0 | 4 | 6 | 1 | 3 | 2 |

0 | 7 | 5 | 4 | 2 | 3 |

Naively, each sum query would then take $O(NM)$ time, for a total of $O(QNM)$. This is too slow.

Let's take the following example region, which we want to sum:

0 | 0 | 0 | 0 | 0 | 0 |

0 | 1 | 5 | 6 | 11 | 8 |

0 | 1 | 7 | 11 | 9 | 4 |

0 | 4 | 6 | 1 | 3 | 2 |

0 | 7 | 5 | 4 | 2 | 3 |

Manually summing all the cells, we have a submatrix sum of $7+11+9+6+1+3 = 37$.

The first logical optimization would be to do one-dimensional prefix sums of each row. Then, we'd have the following row-prefix sum matrix. The desired subarray sum of each row in our desired region is simply the green cell minus the red cell in that respective row. We do this for each row to get $(28-1) + (14-4) = 37$.

0 | 0 | 0 | 0 | 0 | 0 |

0 | 1 | 6 | 12 | 23 | 31 |

0 | 1 | 8 | 19 | 28 | 32 |

0 | 4 | 10 | 11 | 14 | 16 |

0 | 7 | 12 | 16 | 18 | 21 |

Now, if we wanted to find a submatrix sum, we could break up the submatrix into a subarray for each row, and then add their sums, which would be calculated using the prefix sums method described earlier. Since the matrix has $N$ rows, the time complexity of this is $O(QN)$. This might be fast enough for $Q=10^5$ and $N=10^3$, but we can do better.

In fact, we can do two-dimensional prefix sums. In our two dimensional prefix sum array, we have

$\texttt{prefix}[a][b]=\sum_{i=1}^{a} \sum_{j=1}^{b} \texttt{arr}[i][j].$This can be calculated as follows for row index $1 \leq i \leq n$ and column index $1 \leq j \leq m$:

$\begin{aligned} \texttt{prefix}[i][j] =& \, \texttt{prefix}[i-1][j]+ \texttt{prefix}[i][j-1] \\ &- \texttt{prefix}[i-1][j-1]+ \texttt{arr}[i][j] \end{aligned}$The submatrix sum between rows $a$ and $A$ and columns $b$ and $B$, can thus be expressed as follows:

$\begin{aligned} \sum_{i=a}^{A} \sum_{j=b}^{B} \texttt{arr}[i][j]=&\,\texttt{prefix}[A][B] - \texttt{prefix}[a-1][B] \\ &- \texttt{prefix}[A][b-1] + \texttt{prefix}[a-1][b-1] \end{aligned}$Summing the blue region from above using the 2D prefix sums method, we add the value of the green square, subtract the values of the red squares, and then add the value of the gray square. In this example, we have

$65-23-6+1 = 37,$as expected.

0 | 0 | 0 | 0 | 0 | 0 |

0 | 1 | 6 | 12 | 23 | 31 |

0 | 2 | 14 | 31 | 51 | 63 |

0 | 6 | 24 | 42 | 65 | 79 |

0 | 13 | 36 | 58 | 83 | 100 |

Since no matter the size of the submatrix we are summing, we only need to access four values of the 2D prefix sum array, this runs in $O(1)$ per query after an $O(NM)$ preprocessing.

Status | Source | Problem Name | Difficulty | Tags | Solution |
---|---|---|---|---|---|

Silver | Easy | ## Show TagsPrefix Sums | External Sol | ||

Gold | Hard | ## Show TagsPrefix Sums, Max Subarray Sum | External Sol | ||

Plat | Very Hard | External Sol |

## More Complex Applications

Instead of storing just the values themselves, you can also take a prefix sum over $i\cdot a_i$, or $10^i \cdot a_i$, for instance. Some math is usually helpful for these problems; don't be afraid to get dirty with algebra!

For instance, we can quickly answer the following type of query:

Find $1\cdot a_l+2\cdot a_{l+1}+3\cdot a_{l+2}+\cdots+(r-l+1)\cdot a_{r}$.

First, define the following:

$\texttt{ps}[i] = a_1+a_2+a_3+a_4+\cdots+a_i$$\texttt{ips}[i] = 1\cdot a_1+2\cdot a_2+\cdots+i\cdot a_i$Then, we have:

$l\cdot a_l + (l+1) \cdot a_{l+1} + \cdots + r \cdot a_r = \texttt{ips}[r]-\texttt{ips}[l-1]$$(l-1) \cdot a_l + (l-1) \cdot a_{l+1} + \cdot + (l-1) \cdot a_r = (l-1)(\texttt{ps}[r]-\texttt{ps}[l-1])$And so,

$1\cdot a_l + 2 \cdot a_{l+1} + \cdots + (r-l+1) \cdot a_r = \texttt{ips}[r]-\texttt{ips}[l-1]-(l-1)(\texttt{ps}[r]-\texttt{ps}[l-1])$Which is what we were looking for!

Status | Source | Problem Name | Difficulty | Tags | Solution |
---|---|---|---|---|---|

KS | Easy | ## Show TagsPrefix Sums | |||

AC | Hard | ## Show TagsPrefix Sums | Check AC | ||

Plat | Insane | External Sol |